(function() {
    'use strict';

    angular
        .module('app')
        .factory('buzzerService', buzzerService);

    buzzerService.$inject = ['$localStorage', '$ionicPlatform', '$cordovaVibration'];

    /* @ngInject */
    function buzzerService($localStorage, $ionicPlatform, $cordovaVibration) {

        $localStorage.hardware.buzzer = $localStorage.hardware.buzzer || {};

        var storage = $localStorage.hardware.buzzer;

        var service = {
            name : "Buzzer",
            type : "buzzer",
            isActuator : true,
            _run : buzzerRun,
            stop : buzzerStop,
            setState : buzzerSetState
        };
        return service;

        ////////////////

        function buzzerRun() {
            if (service.state && service.state.id !== 0 && service.state.id !== storage.lastId) {
                storage.lastId = service.state.id;
                $ionicPlatform.ready(function() {
                    $cordovaVibration.vibrate(parseInt(service.state.value));
                });
            }
        };

        function buzzerStop() {
        };

        function buzzerSetState(state) {
            service.state = state;
            service.run();
        }
    }
})();